<template>
  <div>
    <div class="form-group">
      <label>Load in:</label>
      <div class="input-group mb-3">
        <select ref="template" class="form-control" v-model="selectTemplate">
          <option v-for="item in templateNames" :key="item">{{ item }}</option>
        </select>
        <span class="input-group-addon">
          <i
            class="fa fa-trash"
            @click="deleteTemplate"
            title="remove template"
          />
        </span>
      </div>
    </div>
    <div class="popup_footer">
      <button
        type="button"
        class="btn btn-primary"
        @click="load"
        style="margin: 10px"
        :disabled="templateNames.length == 0"
      >
        Load
      </button>

      <button @click="$emit('on-close')" class="btn btn-default" role="button">
        Close
      </button>
    </div>
  </div>
</template>

<script>
import { ModalBus } from "../eventBus";

export default {
  data() {
    return { templateNames: [], selectTemplate: null };
  },
  created: function() {
    this.templateNames = Object.keys(
      JSON.parse(localStorage.getItem("templates") || "{}")
    );
  },
  props: {},
  methods: {
    load() {
      if (this.selectTemplate) {
        this.$store.dispatch(
          "ACTION_LOAD_TEMPLATE",
          JSON.parse(localStorage.getItem("templates") || "{}")[
            this.$refs.template.value || "default"
          ] || {}
        );
        ModalBus.$emit("showNotify", {
          type: "info",
          text: "Load success."
        });
        this.$emit("on-close");
      }
    },
    deleteTemplate() {
      if (confirm("Do you really want to delete?")) {
        let templates = JSON.parse(localStorage.getItem("templates") || "{}");

        this.templateNames = this.templateNames.filter(
          template => template !== this.$refs.template.value
        );
        this.$delete(templates, this.$refs.template.value);
        localStorage.setItem("templates", JSON.stringify(templates));
      }
    }
  }
};
</script>

<style scoped>
.fa-trash {
  cursor: pointer;
}

.fa-trash:hover {
  color: #337ab7;
}
</style>
